'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = _interopDefault(require('prop-types'));

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

/**
 * Component that call callback if you click outside of it
 */

var LostFocusHandler = function (_Component) {
  inherits(LostFocusHandler, _Component);

  function LostFocusHandler(props) {
    classCallCheck(this, LostFocusHandler);

    var _this = possibleConstructorReturn(this, (LostFocusHandler.__proto__ || Object.getPrototypeOf(LostFocusHandler)).call(this, props));

    _this.setWrapperRef = _this.setWrapperRef.bind(_this);
    _this.handleClickOutside = _this.handleClickOutside.bind(_this);
    return _this;
  }

  createClass(LostFocusHandler, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      document.addEventListener('mousedown', this.handleClickOutside);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener('mousedown', this.handleClickOutside);
    }

    /**
     * Set the wrapper ref
     */

  }, {
    key: 'setWrapperRef',
    value: function setWrapperRef(node) {
      this.wrapperRef = node;
    }

    /**
     * Call callback if clicked on outside of element
     */

  }, {
    key: 'handleClickOutside',
    value: function handleClickOutside(event) {
      if (this.wrapperRef && !this.wrapperRef.contains(event.target) && this.props.onClickOutside) {
        this.props.onClickOutside();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return React__default.createElement(
        'div',
        { ref: this.setWrapperRef },
        this.props.children
      );
    }
  }]);
  return LostFocusHandler;
}(React.Component);


LostFocusHandler.propTypes = {
  children: PropTypes.element.isRequired
};

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".btn-default {\n    background-color: #f4f4f4 !important;\n}\n\n.open {\n    display: block;\n    /*margin-left: inherit !important;*/\n    padding-left: inherit !important;\n    min-width: 100%;\n}\n\n.dropdown-menu {\n    /*top: 3%;\n    padding: 5px 2px;*/\n    position: absolute;\n\n    top: 100%;\n    left: 0;\n    z-index: 1000;\n    float: left;\n    min-width: 100%;\n    padding: 10px 0px 5px 0px;\n    margin: 3px 0 0;\n    font-size: 14px;\n    text-align: left;\n    list-style: none;\n    background-color: #fff;\n    -webkit-background-clip: padding-box;\n    background-clip: padding-box;\n    border: 1px solid #ccc;\n    border: 1px solid rgba(0, 0, 0, .15);\n    border-radius: 4px;\n    -webkit-box-shadow: 0 6px 12px rgba(0, 0, 0, .175);\n    box-shadow: 0 6px 12px rgba(0, 0, 0, .175);\n    \n}\n\n.dropdown-menu.inner {\n    position: static;\n    border: 0;\n    padding: 0;\n    margin: 0;\n    border-radius: 0;\n    box-shadow: none;\n    overflow-y: auto;\n    max-height: 150px;\n}\n\n.dropdown-menu>ul {\n    width: 100%;\n}\n\n.dropdown-menu>li>a {\n    width: 100%;\n    padding-right: 0px;\n}\n.dropdown-menu>li>a:hover {\n     background-color: #e1e3e9;\n    color: #333;\n}\n\n.dropdown-menu>li>a>span {\n    /*position: absolute;*/\n    float: right;\n    display: inline-block;\n    right: 15px;\n}\n\n.bs-searchbox {\n    padding-right: 10px;\n    padding-left: 10px;\n    padding-bottom: 4px;\n}\n\n.bs-actionsbox {\n    padding-left: 10px;\n    padding-right: 10px;\n    padding-bottom: 4px;\n}\n\n.input-box {\n    width:200px;\n    position:relative;\n}\n\n.button-dropdown {\n    width:100%;\n}\n\n.btn .caret {\n    margin-left: 0;\n    float: right;\n    margin-top: 9px;\n}\n\n.select-all-button {\n    width: 47.5%;\n    margin-right: 2.5% !important;\n\tpadding: 3%;\n}\n\n.deselect-all-button {\n    width: 47.5%;\n\tmargin-left: 2.5% !important;\n\ttext-align: center;\n\tpadding: 3%;\n}\n\n.btn-group > .btn:last-child:not(:first-child), .btn-group > .dropdown-toggle:not(:first-child) {\n    border-top-left-radius: 4px !important;\n    border-bottom-left-radius: 4px !important;\n    /*padding: 0px;*/\n}\n\n.btn-group > .btn:first-child:not(:last-child):not(.dropdown-toggle) {\n    border-top-right-radius: 4px !important;\n    border-bottom-right-radius: 4px !important;\n    /*padding: 0px;*/\n}\n\n.hide {\n    display: none\n}\n\n.special-title {\n    overflow:hidden;\n    width: 93%;\n    text-align: left;\n}\n\n.noselect {\n    -webkit-touch-callout: none; /* iOS Safari */\n      -webkit-user-select: none; /* Safari */\n       -khtml-user-select: none; /* Konqueror HTML */\n         -moz-user-select: none; /* Firefox */\n          -ms-user-select: none; /* Internet Explorer/Edge */\n              user-select: none; /* Non-prefixed version, currently\n                                    supported by Chrome and Opera */\n  }";
styleInject(css);

var Combobox = function (_Component) {
  inherits(Combobox, _Component);

  /* html ids */
  function Combobox(props) {
    classCallCheck(this, Combobox);

    var _this = possibleConstructorReturn(this, (Combobox.__proto__ || Object.getPrototypeOf(Combobox)).call(this, props));

    _this.placeholderDefault = "";
    _this.maxCaptionItems = 0;
    _this.maxDropdownItems = 6;

    _this.onChange = function () {};

    _this.labels = {
      "cap.select.empty": "Select an item",
      "cap.select.singular": "1 item selected",
      "cap.select.plural": "{size} items selected",
      "btn.select.all": "All",
      "btn.unselect.all": "Clear"
    };
    _this.isMultiSelect = false;
    _this.showButtons = false;
    _this.showSearch = false;
    _this.id = undefined;
    _this.idRbc = undefined;
    _this.idMenuButton = undefined;
    _this.idSelectAll = undefined;
    _this.idDeselectAll = undefined;
    _this.idList = undefined;

    _this.closeOrOpen = function () {
      _this.setState({ isOpen: !_this.state.isOpen });
    };

    _this.getLabelSelected = function (sizeSelected) {
      var result = _this.labels["cap.select.singular"];
      if (sizeSelected > 1) {
        result = _this.labels["cap.select.plural"];
      }

      result = result.replace("{sel}", sizeSelected);
      return result.replace("{size}", _this.state.data.length);
    };

    _this.searchElementInArray = function (array, element) {
      var findElement = function findElement(each) {
        return element.label === each.label && element.index === each.index;
      };

      return array.find(findElement);
    };

    _this.selectElement = function (element) {

      if (_this.isMultiSelect) {
        var newSelected = [].concat(toConsumableArray(_this.state.selected));

        if (_this.searchElementInArray(newSelected, element) !== undefined) {
          newSelected = newSelected.filter(function (each) {
            return each.index !== element.index;
          });
        } else {
          newSelected.push(element);
        }

        var newPlaceholder = newSelected.length > _this.maxCaptionItems ? _this.getLabelSelected(newSelected.length) : newSelected.map(function (each) {
          return each.label;
        }).join(", ");

        _this.setState({ selected: newSelected, placeholder: newPlaceholder });

        _this.runCallback(newSelected);
      } else {
        _this.setState({ selected: [element], placeholder: element.label });

        _this.runCallback([element]);
      }
    };

    _this.selectAllElements = function () {
      var compare = function compare(toCompare) {
        return function (current) {
          return toCompare.filter(function (other) {
            return other.index == current.index;
          }).length == 0;
        };
      };

      var onlyInDataFiltered = _this.state.dataFiltered.filter(compare(_this.state.selected));

      var newSelected = _this.state.selected.concat(onlyInDataFiltered);

      var newPlaceholder = newSelected.length > _this.maxCaptionItems ? _this.getLabelSelected(newSelected.length) : newSelected.map(function (each) {
        return each.label;
      }).join(", ");
      _this.setState({ selected: newSelected, placeholder: newPlaceholder });

      _this.runCallback(newSelected);
    };

    _this.deselectAllElements = function () {
      _this.setState({ selected: [], placeholder: _this.placeholderDefault });
      _this.runCallback([]);
    };

    _this.filterData = function (event) {
      _this.setState({
        dataFiltered: _this.state.data.filter(function (each) {
          return each.label.toLowerCase().startsWith(event.target.value.toLowerCase());
        })
      });
    };

    _this.render = function () {
      return React__default.createElement(
        LostFocusHandler,
        { onClickOutside: function onClickOutside() {
            return _this.setState({ isOpen: false });
          } },
        React__default.createElement(
          "div",
          { id: _this.idRbc, className: "input-box" },
          React__default.createElement(
            "button",
            {
              id: _this.idMenuButton,
              onClick: _this.closeOrOpen,
              type: "button",
              className: "btn btn-default dropdown-toggle show-special-title button-dropdown"
            },
            React__default.createElement("span", { className: "pull-left filter-option" }),
            React__default.createElement(
              "span",
              { className: "pull-left special-title" },
              _this.state.placeholder ? _this.state.placeholder : _this.placeholderDefault
            ),
            "\xA0",
            React__default.createElement("span", { className: "caret" })
          ),
          React__default.createElement(
            "div",
            { className: "dropdown-menu " + (_this.state.isOpen ? "open" : "") },
            React__default.createElement(
              "div",
              { className: "bs-searchbox " + (_this.showSearch ? "" : "hide") },
              React__default.createElement("input", {
                type: "text",
                className: "form-control",
                onChange: _this.filterData
              })
            ),
            React__default.createElement(
              "div",
              {
                className: "bs-actionsbox " + (_this.isMultiSelect && _this.showButtons ? "" : "hide")
              },
              React__default.createElement(
                "div",
                { className: "btn-group btn-block" },
                React__default.createElement(
                  "button",
                  {
                    id: _this.idSelectAll,
                    onClick: _this.selectAllElements,
                    type: "button",
                    className: "actions-btn bs-select-all btn btn-default select-all-button"
                  },
                  _this.labels["btn.select.all"]
                ),
                React__default.createElement(
                  "button",
                  {
                    id: _this.idDeselectAll,
                    onClick: _this.deselectAllElements,
                    type: "button",
                    className: "actions-btn bs-deselect-all btn btn-default deselect-all-button"
                  },
                  _this.labels["btn.unselect.all"]
                )
              )
            ),
            React__default.createElement(
              "ul",
              {
                id: _this.idList,
                className: "dropdown-menu inner",
                style: {
                  maxHeight: _this.maxDropdownItems
                }
              },
              " ",
              _this.state.dataFiltered.map(function (each) {
                return React__default.createElement(
                  "li",
                  { className: "noselect", key: each.label + each.index },
                  React__default.createElement(
                    "a",
                    {
                      onClick: function onClick() {
                        if (!_this.isMultiSelect) _this.closeOrOpen();
                        _this.selectElement(each);
                      }
                    },
                    each.label,
                    React__default.createElement("span", {
                      className: _this.searchElementInArray(_this.state.selected, each) !== undefined ? "glyphicon glyphicon-ok" : ""
                    })
                  )
                );
              })
            )
          )
        )
      );
    };

    if (_this.props.labels) {
      if (_this.props.labels["cap.select.empty"]) _this.labels["cap.select.empty"] = _this.props.labels["cap.select.empty"];
      if (_this.props.labels["cap.select.plural"]) {
        _this.labels["cap.select.plural"] = _this.props.labels["cap.select.plural"];
        _this.labels["cap.select.singular"] = _this.props.labels["cap.select.singular"] ? _this.props.labels["cap.select.singular"] : _this.props.labels["cap.select.plural"];
      } else {
        _this.labels["cap.select.singular"] = _this.props.labels["cap.select.singular"] ? _this.props.labels["cap.select.singular"] : _this.labels["cap.select.singular"];
      }

      if (_this.props.labels["btn.select.all"]) _this.labels["btn.select.all"] = _this.props.labels["btn.select.all"];
      if (_this.props.labels["btn.unselect.all"]) _this.labels["btn.unselect.all"] = _this.props.labels["btn.unselect.all"];
    }

    if (_this.props.id) {
      _this.id = _this.props.id;
      _this.idRbc = "rbc-" + _this.id;
      _this.idMenuButton = "rbc-menu-button-" + _this.id;
      _this.idSelectAll = "rbc-menu-button-selectall-button-" + _this.id;
      _this.idDeselectAll = "rbc-menu-button-deselectall-button-" + _this.id;
      _this.idList = "rbc-menu-button-dropdown-list-" + _this.id;
    }
    if (_this.props.onChange && typeof _this.props.onChange === 'function') {
      _this.onChange = _this.props.onChange;
    }

    _this.placeholderDefault = _this.labels["cap.select.empty"];
    _this.maxCaptionItems = _this.props.maxCaptionItems ? _this.props.maxCaptionItems : 0;
    _this.isMultiSelect = _this.props.isMultiSelect ? _this.props.isMultiSelect : false;
    _this.showSearch = _this.props.showSearch ? _this.props.showSearch : false;
    _this.showButtons = _this.props.showButtons ? _this.props.showButtons : false;

    _this.maxDropdownItems = _this.props.maxDropdownItems ? (3 + 20 + 3) * _this.props.maxDropdownItems + "px" : (3 + 20 + 3) * 6 + "px";

    _this.state = {
      placeholder: "",
      isOpen: false,
      dataFiltered: _this.props.data ? _this.props.data.map(function (each, index) {
        return { label: each, index: index };
      }) : [],
      selected: [],
      data: _this.props.data ? _this.props.data.map(function (each, index) {
        return { label: each, index: index };
      }) : []
    };

    return _this;
  }

  createClass(Combobox, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      if (JSON.stringify(this.props.data.map(function (each, index) {
        return { label: each, index: index };
      })) !== JSON.stringify(this.state.data)) {
        this.setState({
          data: this.props.data.map(function (each, index) {
            return { label: each, index: index };
          }),
          dataFiltered: this.props.data.map(function (each, index) {
            return { label: each, index: index };
          }),
          selected: []
        });

        this.runCallback([]);
      }
    }
  }, {
    key: "runCallback",
    value: function runCallback(selection) {
      if (this.props.onChange) {
        this.props.onChange(selection);
      }
    }
  }]);
  return Combobox;
}(React.Component);

var Combobox$1 = /*#__PURE__*/Object.freeze({
  default: Combobox
});

var Combobox$2 = ( Combobox$1 && Combobox ) || Combobox$1;

var src = Combobox$2.default || Combobox$2;

module.exports = src;
//# sourceMappingURL=index.js.map
